/*
    This is part of mxldump.
    B-record generation routines.
    Copyright (C) 2006 2007  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __BREC__
#define __BREC__	1

/***************************************************************************/
/* define pubblici */

/* Available modes */
#define BYTE_M		0x00	// byte mode
#define WORD_M		0x40	// word mode
#define DWORD_M		0xc0	// dword mode

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

void WriteBrecord(unsigned long int Addr,unsigned long int Data,char *Str,
		unsigned char Mode);
  /* Dato un valore a 32bit e l'indirizzo di memoria in cui va inserito
     crea un B-record contenente i dati specificati. La stringa viene creata
     all'interno del buffer Str e viene terminata. */

void ReadBrecord(unsigned long int Addr,char *Str,unsigned char Mode);
  /* Dato l'indirizzo di memoria da cui si desidera leggere crea un
     B-record che esegue l'operazione. La stringa viene creata
     all'interno del buffer Str e viene terminata. */

void EntryBrecord(unsigned long int Addr,char *Str);
  /* Crea un B-record contenente il punto di avvio del programma.
     La stringa viene creata nel buffer Str e viene terminata. */

int RecordExchange(int SerialFD,char *Record,unsigned long int *Recv);
  /* Invia la stringa passata sulla seriale e riceve l'eco fino all'arrivo
     del char '/'. L'attesa e' limitata ad un timeout. In caso di successo
     la funzione ritorna 0 e in Recv restituisce l'ultima dword ricevuta. */
     
/***************************************************************************/
#endif

/* $Source$ */

