/*
    This is part of mxldump.
    Hexadecimal conversion routines.
    Copyright (C) 2006 2007  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __HEX__
#define __HEX__		1

/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

char HighChar(unsigned char Byte);
  /* Dato un valore a 8 bit restituisce la cifra esadecimale che rappresenta
     il valore del nibble alto. */

char LowChar(unsigned char Byte);
  /* Dato un valore a 8 bit restituisce la cifra esadecimale che rappresenta
     il valore del nibble basso. */

char *ByteToHex(unsigned char Byte,char *Str);
  /* Dato in ingresso un valore a 8 bit produce la sua rappresentazione
     in forma esadecimale all'interno di Str. La stringa viene terminata,
     in uscita viene restituito un puntatore al terminatore. */
     
char *LongToHex(unsigned long int Long,char *Str);
  /* Dato in ingresso un valore a 32 bit produce la sua rappresentazione
     in forma esadecimale all'interno di Str. La stringa viene terminata,
     in uscita viene restituito un puntatore al terminatore. */

unsigned long int HexToLong(char *Str);
  /* Data in ingresso una stringa rappresentante un valore a 32 bit in
     forma esadecimale restituisce il valore coma intero senza segno. */

/***************************************************************************/
#endif

/* $Source$ */

