/*
    Text mode progress bar implementation.
    Copyright (C) 2007  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

static const char rcsid[]="$Id$";


/***************************************************************************/
/* include vari */

#include <stdio.h>

/***************************************************************************/
/* define interni alla libreria */

/***************************************************************************/
/* strutture contenute all'interno della libreria */

/***************************************************************************/
/* costanti interne alla libreria */

static const char	EmptyBar[]=".............................."
					"....................\r";
static const char	NullBar[]="--------------------unused bar"
					"--------------------\r";

/***************************************************************************/
/* variabili interne alla libreria */

static float	BarTotal;		// valore finale della barra
static float	BarCurrent;		// valore corrente della barra
static float	BarPerc;		// valore corrente percentuale

/***************************************************************************/
/* funzioni interne alla libreria */

/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

void InitProgressBar(long int TotalSize);
  /* Inizializza la gestione della progress bar e stampa sullo stdout la
     barra vuota. */

void IncrementBarOf(long int Step);
  /* Incrementa il valore della progress bar del valore indicato, la barra a
     video viene aggiornata solo se necessario. */

/***************************************************************************/
/* funzioni */

void InitProgressBar(long int TotalSize)
{
  /* Inizializza la gestione della progress bar e stampa sullo stdout la
     barra vuota. */


     
  /* imposta lo stato della barra */
  BarTotal=(float)TotalSize;
  BarCurrent=0.0;
  BarPerc=0.0;

  /* visualizza la barra di riferimento */
  if(BarTotal==0.0)
    printf(NullBar);				// visualizza la barra
  else
    printf(EmptyBar);				// visualizza la barra
  fflush(stdout);				// aggiorna stdout
  return;					// termina
}



void IncrementBarOf(long int Step)
{
  /* Incrementa il valore della progress bar del valore indicato, la barra a
     video viene aggiornata solo se necessario. */


     
  float	NewBarPerc;				// nuovo aggiornamento
  int	i;



  if(BarTotal==0.0)
    return;					// termina senza azioni
  BarCurrent+=(float)Step;			// nuovo livello
  NewBarPerc=BarCurrent/BarTotal;		// nuova percentuale
  i=(int)((NewBarPerc-BarPerc)*50);		// numero di punti aggiunti
  if(i>0)
    BarPerc=NewBarPerc;				// aggiorna percentuale
  while(i>0)
  {
    putchar('o');				// allunga la barra
    fflush(stdout);				// aggiorna stdout
    --i;					// decrementa il contatore
  }
  return;					// termina
}

/* $Source$ */

